/*
 * Copyright (c) 2001, Aslak Hellesy, BEKK Consulting
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * - Neither the name of BEKK Consulting nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
package middlegen.plugins.entitybean;

import middlegen.MiddlegenException;

/**
 * @author hdeadman This class allows MVCSoft specific server settings to be
 *      supplied to the velocity template The settings in this bean will apply
 *      to all entity beans, if appropriate
 * @created 6. desember 2002
 */
public class MVCSoft extends Server {

   // initialize all variables so null
   // won't be returned to velocity template
   /**
    * @todo-javadoc Describe the field
    */
   private String cache = "CommitOptionA";
   /**
    * @todo-javadoc Describe the field
    */
   private String insert = "AtTransactionCompletion";
   /**
    * @todo-javadoc Describe the field
    */
   private String delete = "AtTransactionCompletion";
   /**
    * @todo-javadoc Describe the field
    */
   private String lockingstrategy = "None";
   /**
    * @todo-javadoc Describe the field
    */
   private String lockcolname = "";
   /**
    * @todo-javadoc Describe the field
    */
   private String lockcolsqltype = "";
   /**
    * @todo-javadoc Describe the field
    */
   private String dataexpires = "";
   /**
    * @todo-javadoc Describe the field
    */
   private String uuidipaddress = "4";
   /**
    * @todo-javadoc Describe the field
    */
   private String uuidkeyfieldtype = "String";
   /**
    * @todo-javadoc Describe the field
    */
   private String uuidkeyclassstarttime = "4";
   /**
    * @todo-javadoc Describe the field
    */
   private String uuidkeytimestamp = "6";
   /**
    * @todo-javadoc Describe the field
    */
   private String uuidkeycounter = "2";
   /**
    * @todo-javadoc Describe the field
    */
   private String uuidkeyclasshash = "4";
   /**
    * @todo-javadoc Describe the field
    */
   private String hlkeynontransactionalpoolname = "java:/NonTxChangeMeDS";
   /**
    * @todo-javadoc Describe the field
    */
   private String hlkeychunksize = "5";
   /**
    * @todo-javadoc Describe the field
    */
   private String hlkeyretrycount = "3";
   /**
    * @todo-javadoc Describe the field
    */
   private String hlkeytablename = "MVCHighLow";
   /**
    * @todo-javadoc Describe the field
    */
   private String hlkeysequencenamecolumn = "SequenceName";
   /**
    * @todo-javadoc Describe the field
    */
   private String hlkeysequencenamesqltype = "varchar2(30)";
   /**
    * @todo-javadoc Describe the field
    */
   private String hlkeyvaluecolumn = "UsedIncrements";
   /**
    * @todo-javadoc Describe the field
    */
   private String hlkeyvaluesqltype = "int";
   /**
    * @todo-javadoc Describe the field
    */
   private boolean cmrmethodsreturnlightweight = false;
   /**
    * @todo-javadoc Describe the field
    */
   private boolean queryshouldflush = false;
   /**
    * @todo-javadoc Describe the field
    */
   private boolean pkgen = false;


   /**
    * Sets the cache.
    *
    * @param cache The cache to set
    */
   public void setCache(String cache) {
      this.cache = cache;
   }


   /**
    * Sets the dataexpires.
    *
    * @param dataexpires The dataexpires to set
    */
   public void setDataexpires(String dataexpires) {
      this.dataexpires = dataexpires;
   }


   /**
    * Sets the delete.
    *
    * @param delete The delete to set
    */
   public void setDelete(String delete) {
      this.delete = delete;
   }


   /**
    * Sets the hlkeychunksize.
    *
    * @param hlkeychunksize The hlkeychunksize to set
    */
   public void setHlkeychunksize(String hlkeychunksize) {
      this.hlkeychunksize = hlkeychunksize;
   }


   /**
    * Sets the hlkeynontransactionalpoolname.
    *
    * @param hlkeynontransactionalpoolname The hlkeynontransactionalpoolname to
    *      set
    */
   public void setHlkeynontransactionalpoolname(String hlkeynontransactionalpoolname) {
      this.hlkeynontransactionalpoolname = hlkeynontransactionalpoolname;
   }


   /**
    * Sets the hlkeyretrycount.
    *
    * @param hlkeyretrycount The hlkeyretrycount to set
    */
   public void setHlkeyretrycount(String hlkeyretrycount) {
      this.hlkeyretrycount = hlkeyretrycount;
   }


   /**
    * Sets the hlkeysequencenamecolumn.
    *
    * @param hlkeysequencenamecolumn The hlkeysequencenamecolumn to set
    */
   public void setHlkeysequencenamecolumn(String hlkeysequencenamecolumn) {
      this.hlkeysequencenamecolumn = hlkeysequencenamecolumn;
   }


   /**
    * Sets the hlkeysequencenamesqltype.
    *
    * @param hlkeysequencenamesqltype The hlkeysequencenamesqltype to set
    */
   public void setHlkeysequencenamesqltype(String hlkeysequencenamesqltype) {
      this.hlkeysequencenamesqltype = hlkeysequencenamesqltype;
   }


   /**
    * Sets the hlkeytablename.
    *
    * @param hlkeytablename The hlkeytablename to set
    */
   public void setHlkeytablename(String hlkeytablename) {
      this.hlkeytablename = hlkeytablename;
   }


   /**
    * Sets the hlkeyvaluecolumn.
    *
    * @param hlkeyvaluecolumn The hlkeyvaluecolumn to set
    */
   public void setHlkeyvaluecolumn(String hlkeyvaluecolumn) {
      this.hlkeyvaluecolumn = hlkeyvaluecolumn;
   }


   /**
    * Sets the hlkeyvaluesqltype.
    *
    * @param hlkeyvaluesqltype The hlkeyvaluesqltype to set
    */
   public void setHlkeyvaluesqltype(String hlkeyvaluesqltype) {
      this.hlkeyvaluesqltype = hlkeyvaluesqltype;
   }


   /**
    * Sets the insert.
    *
    * @param insert The insert to set
    */
   public void setInsert(String insert) {
      this.insert = insert;
   }


   /**
    * Sets the lockcolname.
    *
    * @param lockcolname The lockcolname to set
    */
   public void setLockcolname(String lockcolname) {
      this.lockcolname = lockcolname;
   }


   /**
    * Sets the lockcolsqltype.
    *
    * @param lockcolsqltype The lockcolsqltype to set
    */
   public void setLockcolsqltype(String lockcolsqltype) {
      this.lockcolsqltype = lockcolsqltype;
   }


   /**
    * Sets the lockingstrategy.
    *
    * @param lockingstrategy The lockingstrategy to set
    */
   public void setLockingstrategy(String lockingstrategy) {
      this.lockingstrategy = lockingstrategy;
   }


   /**
    * Sets the queryshouldflush.
    *
    * @param queryshouldflush The queryshouldflush to set
    */
   public void setQueryshouldflush(boolean queryshouldflush) {
      this.queryshouldflush = queryshouldflush;
   }


   /**
    * Sets the cmrmethodsreturnlightweight.
    *
    * @param cmrmethodsreturnlightweight The cmrmethodsreturnlightweight to set
    */
   public void setCmrmethodsreturnlightweight(boolean cmrmethodsreturnlightweight) {
      this.cmrmethodsreturnlightweight = cmrmethodsreturnlightweight;
   }


   /**
    * Sets the uuidkeyclasshash.
    *
    * @param uuidkeyclasshash The uuidkeyclasshash to set
    */
   public void setUuidkeyclasshash(String uuidkeyclasshash) {
      this.uuidkeyclasshash = uuidkeyclasshash;
   }


   /**
    * Sets the uuidkeyclassstarttime.
    *
    * @param uuidkeyclassstarttime The uuidkeyclassstarttime to set
    */
   public void setUuidkeyclassstarttime(String uuidkeyclassstarttime) {
      this.uuidkeyclassstarttime = uuidkeyclassstarttime;
   }


   /**
    * Sets the uuidkeycounter.
    *
    * @param uuidkeycounter The uuidkeycounter to set
    */
   public void setUuidkeycounter(String uuidkeycounter) {
      this.uuidkeycounter = uuidkeycounter;
   }


   /**
    * Sets the uuidkeyfieldtype.
    *
    * @param uuidkeyfieldtype The uuidkeyfieldtype to set
    */
   public void setUuidkeyfieldtype(String uuidkeyfieldtype) {
      this.uuidkeyfieldtype = uuidkeyfieldtype;
   }


   /**
    * Sets the uuidkeytimestamp.
    *
    * @param uuidkeytimestamp The uuidkeytimestamp to set
    */
   public void setUuidkeytimestamp(String uuidkeytimestamp) {
      this.uuidkeytimestamp = uuidkeytimestamp;
   }


   /**
    * Sets the pkgen.
    *
    * @param pkgen The pkgen to set
    */
   public void setPkgen(boolean pkgen) {
      this.pkgen = pkgen;
   }


   /**
    * Sets the uuidipaddress.
    *
    * @param uuidipaddress The uuidipaddress to set
    */
   public void setUuidipaddress(String uuidipaddress) {
      this.uuidipaddress = uuidipaddress;
   }



   /**
    * @return The ServerName value
    * @see middlegen.plugins.entitybean.Server#getServerName()
    */
   public String getServerName() {
      return "MVCSoft Persistence Manager";
   }


   /**
    * Returns the cache.
    *
    * @return String
    */
   public String getCache() {
      return cache;
   }


   /**
    * Returns the dataexpires.
    *
    * @return String
    */
   public String getDataexpires() {
      return dataexpires;
   }


   /**
    * Returns the delete.
    *
    * @return String
    */
   public String getDelete() {
      return delete;
   }


   /**
    * Returns the hlkeychunksize.
    *
    * @return String
    */
   public String getHlkeychunksize() {
      return hlkeychunksize;
   }


   /**
    * Returns the hlkeynontransactionalpoolname.
    *
    * @return String
    */
   public String getHlkeynontransactionalpoolname() {
      return hlkeynontransactionalpoolname;
   }


   /**
    * Returns the hlkeyretrycount.
    *
    * @return String
    */
   public String getHlkeyretrycount() {
      return hlkeyretrycount;
   }


   /**
    * Returns the hlkeysequencenamecolumn.
    *
    * @return String
    */
   public String getHlkeysequencenamecolumn() {
      return hlkeysequencenamecolumn;
   }


   /**
    * Returns the hlkeysequencenamesqltype.
    *
    * @return String
    */
   public String getHlkeysequencenamesqltype() {
      return hlkeysequencenamesqltype;
   }


   /**
    * Returns the hlkeytablename.
    *
    * @return String
    */
   public String getHlkeytablename() {
      return hlkeytablename;
   }


   /**
    * Returns the hlkeyvaluecolumn.
    *
    * @return String
    */
   public String getHlkeyvaluecolumn() {
      return hlkeyvaluecolumn;
   }


   /**
    * Returns the hlkeyvaluesqltype.
    *
    * @return String
    */
   public String getHlkeyvaluesqltype() {
      return hlkeyvaluesqltype;
   }


   /**
    * Returns the insert.
    *
    * @return String
    */
   public String getInsert() {
      return insert;
   }


   /**
    * Returns the lockcolname.
    *
    * @return String
    */
   public String getLockcolname() {
      return lockcolname;
   }


   /**
    * Returns the lockcolsqltype.
    *
    * @return String
    */
   public String getLockcolsqltype() {
      return lockcolsqltype;
   }


   /**
    * Returns the lockingstrategy.
    *
    * @return String
    */
   public String getLockingstrategy() {
      return lockingstrategy;
   }


   /**
    * Returns the queryshouldflush.
    *
    * @return boolean
    */
   public boolean getQueryshouldflush() {
      return queryshouldflush;
   }


   /**
    * Returns the cmrmethodsreturnlightweight.
    *
    * @return boolean
    */
   public boolean getCmrmethodsreturnlightweight() {
      return cmrmethodsreturnlightweight;
   }


   /**
    * Returns the uuidkeyclasshash.
    *
    * @return String
    */
   public String getUuidkeyclasshash() {
      return uuidkeyclasshash;
   }


   /**
    * Returns the uuidkeyclassstarttime.
    *
    * @return String
    */
   public String getUuidkeyclassstarttime() {
      return uuidkeyclassstarttime;
   }


   /**
    * Returns the uuidkeycounter.
    *
    * @return String
    */
   public String getUuidkeycounter() {
      return uuidkeycounter;
   }


   /**
    * Returns the uuidkeyfieldtype.
    *
    * @return String
    */
   public String getUuidkeyfieldtype() {
      return uuidkeyfieldtype;
   }


   /**
    * Returns the uuidkeytimestamp.
    *
    * @return String
    */
   public String getUuidkeytimestamp() {
      return uuidkeytimestamp;
   }


   /**
    * Returns the pkgen.
    *
    * @return boolean
    */
   public boolean getPkgen() {
      return pkgen;
   }


   /**
    * Returns the uuidipaddress.
    *
    * @return String
    */
   public String getUuidipaddress() {
      return uuidipaddress;
   }


   /**
    * Describe what the method does
    *
    * @exception MiddlegenException Describe the exception
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for exception
    */
   public void validate() throws MiddlegenException {
      super.validate();
   }

}

