/*
 * Copyright (c) 2001, Aslak Hellesy, BEKK Consulting
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 *
 * - Neither the name of BEKK Consulting nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */
package middlegen.swing;

import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.SortedMap;
import java.util.SortedSet;
import java.util.TreeMap;

import javax.swing.*;
import javax.swing.border.*;

import middlegen.Middlegen;
import middlegen.Relation;
import middlegen.Table;

/**
 * <p>
 *
 * Titre : </p> <p>
 *
 * Description : </p> <p>
 *
 * Copyright : Copyright (c) 2004 </p> <p>
 *
 * Socit : </p>
 *
 * @author non attribuable
 * @created 20 aot 2004
 * @version 1.0
 */

public class JMiddlegenFrameRelations extends JDialog {

   /**
    * @version 1.0 04/26/99
    */
   private final Middlegen _middlegen;


   /**
    * Describe what the JMiddlegenFrameRelations constructor does
    *
    * @param _middlegen Describe what the parameter does
    * @todo-javadoc Write javadocs for constructor
    * @todo-javadoc Write javadocs for method parameter
    */
   public JMiddlegenFrameRelations(final Middlegen _middlegen) {
      //super("Etat de slection des tables de la base");

      this._middlegen = _middlegen;
      final JMiddlegenFrameRelations ft = this;
      Iterator it = _middlegen.getRelations().iterator();
      String[] strs = new String[_middlegen.getRelations().size()];
      boolean[] b = new boolean[_middlegen.getRelations().size()];

      SortedMap map = new TreeMap();
      while (it.hasNext()) {
         Relation re = (Relation)it.next();
         map.put(re.getName(), "");
      }

      int i = 0;
      it = map.entrySet().iterator();
      while (it.hasNext()) {

         Map.Entry entry = (Map.Entry)it.next();
         //			System.out.println(" map sorted : " + (String) entry.getKey());

         String sRel = (String)entry.getKey();
         Relation r;
         try {
            r = _middlegen.getRelation(sRel);
            b[i] = r.isBothTablesGenerate() && r.getLeftRole().isEnabled()
                   && r.getRightRole().isEnabled();
            strs[i++] = r.getName();
         } catch (Exception e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
         }
         //b[i++] = r.getisGenerate();
      }

      map.clear();
      map = null;

      final JList list = new JList(createData(strs, b));

      list.setCellRenderer(new CheckListRenderer());
      list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      list.setBorder(new EmptyBorder(0, 4, 0, 0));
      list.addMouseListener(
         new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
               int index = list.locationToIndex(e.getPoint());
               CheckableItem item = (CheckableItem)list.getModel()
                     .getElementAt(index);
               item.setSelected(!item.isSelected());
               Rectangle rect = list.getCellBounds(index, index);
               list.repaint(rect);
            }
         });

      JScrollPane sp = new JScrollPane(list);

      //    final JTextArea textArea = new JTextArea(3, 10);
      //    JScrollPane textPanel = new JScrollPane(textArea);
      JButton closeButton = new JButton("Close");
      closeButton.addActionListener(
         new ActionListener() {
            public void actionPerformed(ActionEvent e) {

               ListModel model = list.getModel();
               int n = model.getSize();
               for (int i = 0; i < n; i++) {
                  CheckableItem item = (CheckableItem)model.getElementAt(i);
                  try {
                     Relation rel = _middlegen.getRelation(item.str);
                     rel.getLeftRole().setEnabled(item.isSelected());
                     rel.getRightRole().setEnabled(item.isSelected());

                  } catch (Exception e1) {
                     // TODO Auto-generated catch block
                     e1.printStackTrace();
                  }
               }
               ft.dispose();
            }
         });
      JButton clearButton = new JButton("clear");
      clearButton.addActionListener(
         new ActionListener() {
            public void actionPerformed(ActionEvent e) {
               //textArea.setText("");
            }
         });
      JPanel panel = new JPanel(new GridLayout(2, 1));
      panel.add(closeButton);
      //    panel.add(clearButton);

      getContentPane().add(sp, BorderLayout.NORTH);
      getContentPane().add(panel, BorderLayout.SOUTH);
      //    getContentPane().add(textPanel, BorderLayout.SOUTH);
   }


   /**
    * Describe what the method does
    *
    * @param strs Describe what the parameter does
    * @param b Describe what the parameter does
    * @return Describe the return value
    * @todo-javadoc Write javadocs for method
    * @todo-javadoc Write javadocs for method parameter
    * @todo-javadoc Write javadocs for method parameter
    * @todo-javadoc Write javadocs for return value
    */
   private CheckableItem[] createData(String[] strs, boolean[] b) {
      int n = strs.length;
      CheckableItem[] items = new CheckableItem[n];
      for (int i = 0; i < n; i++) {
         items[i] = new CheckableItem(strs[i], b[i]);
      }
      return items;
   }


   /**
    * Describe what this class does
    *
    * @author Cnedi
    * @created 20 aot 2004
    * @todo-javadoc Write javadocs
    */
   class CheckableItem {
      /**
       * @todo-javadoc Describe the field
       */
      private String str;

      /**
       * @todo-javadoc Describe the field
       */
      private boolean isSelected;


      /**
       * Describe what the CheckableItem constructor does
       *
       * @param str Describe what the parameter does
       * @todo-javadoc Write javadocs for constructor
       * @todo-javadoc Write javadocs for method parameter
       */
      public CheckableItem(String str) {
         this.str = str;
         isSelected = false;
      }


      /**
       * Describe what the CheckableItem constructor does
       *
       * @param str Describe what the parameter does
       * @param b Describe what the parameter does
       * @todo-javadoc Write javadocs for constructor
       * @todo-javadoc Write javadocs for method parameter
       * @todo-javadoc Write javadocs for method parameter
       */
      public CheckableItem(String str, boolean b) {
         this.str = str;
         isSelected = b;
      }


      /**
       * Sets the Selected attribute of the CheckableItem object
       *
       * @param b The new Selected value
       */
      public void setSelected(boolean b) {
         isSelected = b;
      }


      /**
       * Gets the Selected attribute of the CheckableItem object
       *
       * @return The Selected value
       */
      public boolean isSelected() {
         return isSelected;
      }


      /**
       * Describe what the method does
       *
       * @return Describe the return value
       * @todo-javadoc Write javadocs for method
       * @todo-javadoc Write javadocs for return value
       */
      public String toString() {
         return str;
      }
   }


   /**
    * Describe what this class does
    *
    * @author Cnedi
    * @created 20 aot 2004
    * @todo-javadoc Write javadocs
    */
   class CheckListRenderer extends JCheckBox implements ListCellRenderer {

      /**
       * Describe what the CheckListRenderer constructor does
       *
       * @todo-javadoc Write javadocs for constructor
       */
      public CheckListRenderer() {
         setBackground(UIManager.getColor("List.textBackground"));
         setForeground(UIManager.getColor("List.textForeground"));
      }


      /**
       * Gets the ListCellRendererComponent attribute of the CheckListRenderer
       * object
       *
       * @param list Describe what the parameter does
       * @param value Describe what the parameter does
       * @param index Describe what the parameter does
       * @param isSelected Describe what the parameter does
       * @param hasFocus Describe what the parameter does
       * @return The ListCellRendererComponent value
       * @todo-javadoc Write javadocs for method parameter
       * @todo-javadoc Write javadocs for method parameter
       * @todo-javadoc Write javadocs for method parameter
       * @todo-javadoc Write javadocs for method parameter
       * @todo-javadoc Write javadocs for method parameter
       */
      public Component getListCellRendererComponent(JList list, Object value,
            int index, boolean isSelected, boolean hasFocus) {
         setEnabled(list.isEnabled());
         setSelected(((CheckableItem)value).isSelected());
         setFont(list.getFont());
         setText(value.toString());
         return this;
      }
   }

}
